#include <bits/stdc++.h>

#define long long long int
using namespace std;

// @author: pashka

int main() {
    ios::sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        g[x].push_back({y, c});
        g[y].push_back({x, c});
    }

    vector<int> d(n, -1);
    d[0] = 0;
    vector<int> q = {0};
    for (int i = 0; i < (int) q.size(); i++) {
        int x = q[i];
        for (auto &e : g[x]) {
            int y = e.first;
            if (d[y] == -1) {
                d[y] = d[x] + 1;
                q.push_back(y);
            }
        }
    }

    vector<int> dmn(n, -1);
    vector<int> dmx(n, -1);
    vector<int> p(n, -1);
    dmn[0] = dmx[0] = 0;
    for (int x : q) {
        for (auto &e : g[x]) {
            int y = e.first;
            if (d[y] == d[x] + 1) {
                int mn = min(dmn[x], e.second);
                int mx = max(dmx[x], e.second);
                if (dmn[y] == -1 || mx - mn > dmx[y] - dmn[y]) {
                    dmn[y] = mn;
                    dmx[y] = mx;
                    p[y] = x;
                }
            }
        }
    }
    int x = n - 1;
    vector<int> res;
    while (x != -1) {
        res.push_back(x);
        x = p[x];
    }
    reverse(res.begin(), res.end());

    cout << res.size() - 1 << "\n";
    for (int x : res) cout << x + 1 << " ";

    return 0;
}