/**
 *    author:  tourist
 *    created: 07.12.2021 20:05:36       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int h, w;
  cin >> h >> w;
  vector<string> s(h);
  for (int i = 0; i < h; i++) {
    cin >> s[i];
  }
  map<char, vector<string>> images;

  images['Q'] = {"###",
                 "#.#",
                 "###",
                 "..#",
                 "..#"};
  
  images['F'] = {"###",
                 "#..",
                 "##.",
                 "#..",
                 "#.."};

  map<char, int> cnt;
  auto Draw = [&](int i, int j, char c) {
    assert(i >= 0 && j >= 0 && i + 5 <= h && j + 3 <= w);
    for (int di = 0; di < 5; di++) {
      for (int dj = 0; dj < 3; dj++) {
        if (images[c][di][dj] == '#') {
          assert(s[i + di][j + dj] == '#');
          s[i + di][j + dj] = '.';
        }
      }
    }
    cnt[c] += 1;
  };
  for (int j = w - 1; j >= 0; j--) {
    for (int i = 0; i < h; i++) {
      if (s[i][j] == '#') {
        Draw(i, j - 2, s[i + 1][j] != '.' ? 'Q' : 'F');
      }
    }
  }
  cout << cnt['Q'] << " " << cnt['F'] << '\n';
  return 0;
}
