/**
 *    author:  tourist
 *    created: 28.06.2021 20:46:58       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    map<int, vector<int>> when;
    for (int i = 0; i < n; i++) {
      when[m - a[i] % m].push_back(i);
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
      b[i] = a[i] / m;
    }
    set<int> borders;
    borders.insert(0);
    borders.insert(n);
    for (int i = 1; i < n; i++) {
      if (b[i] - b[i - 1] > 1) {
        borders.insert(i);
      }
    }
    multiset<int> streaks;
    {
      auto iter = borders.begin();
      while (iter != borders.end()) {
        if (*iter < n) {
          streaks.insert(b[(*next(iter)) - 1] - b[*iter] + 1);
        }
        ++iter;
      }
    }
    auto AddBorder = [&](int i) {
      assert(borders.find(i) == borders.end());
      auto iter = borders.insert(i).first;
      int pr = *prev(iter);
      int ne = *next(iter);
      streaks.erase(streaks.find(b[ne - 1] - b[pr] + 1));
      streaks.insert(b[i - 1] - b[pr] + 1);
      streaks.insert(b[ne - 1] - b[i] + 1);
    };
    auto RemoveBorder = [&](int i) {
      auto iter = borders.find(i);
      assert(iter != borders.end());
      int pr = *prev(iter);
      int ne = *next(iter);
      borders.erase(iter);
      streaks.erase(streaks.find(b[i - 1] - b[pr] + 1));
      streaks.erase(streaks.find(b[ne - 1] - b[i] + 1));
      streaks.insert(b[ne - 1] - b[pr] + 1);
    };
    auto Increase = [&](int i) {
      if (i > 0 && b[i] - b[i - 1] == 1) {
        AddBorder(i);
      }
      if (i < n - 1 && b[i + 1] - b[i] == 2) {
        RemoveBorder(i + 1);
      }
      auto iter = borders.find(i);
      if (iter != borders.end()) {
        int ne = *next(iter);
        if (ne - 1 != i) {
          streaks.erase(streaks.find(b[ne - 1] - b[i] + 1));
          streaks.insert(b[ne - 1] - (b[i] + 1) + 1);
        }
      }
      iter = borders.find(i + 1);
      if (iter != borders.end()) {
        int pr = *prev(iter);
        if (pr != i) {
          streaks.erase(streaks.find(b[i] - b[pr] + 1));
          streaks.insert((b[i] + 1) - b[pr] + 1);
        }
      }
      b[i] += 1;
    };
    auto init_borders = borders;
    auto init_streaks = streaks;
    int ans = *streaks.rbegin();
    int zone = 0;
    for (auto& e : when) {
      for (int i : e.second) {
        Increase(i);
      }
      int cur = *streaks.rbegin();
      if (cur > ans) {
        ans = cur;
        zone = e.first;
      }
    }
    assert(init_borders == borders);
    assert(init_streaks == streaks);
    cout << ans << " " << zone << '\n';
  }
  return 0;
}
