fun main() {
    val md = 998244353
    var (n, m, k) = readInts()
    var a = Array(n) {  readInts().toIntArray() }
    fun pow(a: Int, b: Int): Int {
        if (b == 0) {
            return 1
        }
        if (b % 2 == 1) {
            return (pow(a, b - 1).toLong() * a % md).toInt()
        }
        var x = pow(a, b / 2)
        return (x.toLong() * x % md).toInt()
    }
    var fact = IntArray(m + 1)
    var inv_fact = IntArray(m + 1)
    fact[0] = 1
    inv_fact[0] = 1
    for (i in 1..m) {
        fact[i] = (fact[i - 1].toLong() * i % md).toInt()
        inv_fact[i] = pow(fact[i], md - 2)
    }
    var pre = Array(m + 1) { IntArray(m + 1) {0} }
    for (cnt in 0..m) {
        for (c in 0..cnt-1) {
            var cur = 1
            cur = (cur.toLong() * fact[c] % md).toInt()
            cur = (cur.toLong() * fact[cnt - 1 - c] % md).toInt()
            cur = (cur.toLong() * inv_fact[cnt] % md).toInt()
            pre[cnt][c] = cur
        }
    }
    var prob = Array(n) { Array(m) {LongArray(k + 1) {0} } }
    for (i in 0 until n) {
        var cnt = 0
        for (j in 0 until m) {
            if (a[i][j] != 0) {
                cnt += 1
            }
        }
        var dp = Array(cnt + 1) {IntArray(k + 1) {0} }
        dp[0][0] = 1
        for (j in 0 until m) {
            if (a[i][j] != 0) {
                for (c in cnt-1 downTo 0) {
                    for (s in k-a[i][j] downTo 0) {
                        dp[c + 1][s + a[i][j]] += dp[c][s]
                    }
                }
            }
        }
        for (j in 0 until m) {
            if (a[i][j] != 0) {
                for (c in 0 until cnt) {
                    for (s in 0..k-a[i][j]) {
                        dp[c + 1][s + a[i][j]] -= dp[c][s]
                    }
                }
                for (c in 0 until cnt) {
                    for (s in 0..k-a[i][j]) {
                        prob[i][j][s + a[i][j]] = dp[c][s].toLong() * pre[cnt][c] + prob[i][j][s + a[i][j]]
                    }
                }
                for (c in cnt-1 downTo 0) {
                    for (s in k-a[i][j] downTo 0) {
                        dp[c + 1][s + a[i][j]] += dp[c][s]
                    }
                }
            }
        }
    }
    var ans = IntArray(n) {0}
    for (j in 0 until m) {
        var p = IntArray(n) {1}
        for (t in 1..k) {
            var suf = IntArray(n) {1}
            for (i in n-2 downTo 0) {
                suf[i] = (suf[i + 1].toLong() * p[i + 1] % md).toInt()
            }
            var prod = 1
            for (i in 0 until n) {
                prob[i][j][t] %= md.toLong()
                var newProd = (prod.toLong() * p[i] % md).toInt()
                if (prob[i][j][t] != 0L) {
                    var cur = prod
                    cur = (cur.toLong() * suf[i] % md).toInt()
                    cur = (cur.toLong() * prob[i][j][t] % md).toInt()
                    ans[i] += cur
                    if (ans[i] >= md) {
                        ans[i] -= md
                    }
                    p[i] -= prob[i][j][t].toInt()
                    if (p[i] < 0) {
                        p[i] += md
                    }
                }
                prod = newProd
            }
        }
    }
    for (i in 0 until n) {
        println(ans[i])
    }
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }