#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>("n");
	int maxL = opt<int>("maxL");
	int maxV = opt<int>("maxV");
	bool skewLeft = opt<bool>("skew");

	int L = rnd.next(1, maxL);
	int V = rnd.next(1, maxV);
	set<int> s;
	while ((int) s.size() < n) {
	  int x = (int) llround(sqrt(rnd.next(1LL, maxV * 1LL * maxV)));
	  if (skewLeft) {
	    x = maxV - x + 1;
	  }
	  s.insert(x);
	}
	vector<int> v(s.begin(), s.end());

	cout << n << " " << L << " " << V << '\n';
	for (int i = 0; i < n; i++) {
	  if (i > 0) {
	    cout << " ";
	  }
	  cout << v[i];
	}
	cout << '\n';

	return 0;
}